var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g = Object.create((typeof Iterator === "function" ? Iterator : Object).prototype);
    return g.next = verb(0), g["throw"] = verb(1), g["return"] = verb(2), typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import React, { useEffect } from 'react';
import BarChart from './charts/BarChart.js';
import LineChart from './charts/LineChart.js';
import PieChart from './charts/PieChart.js';
import StackChart from './charts/StackChart.js';
export * from './types.js';
var SDashboard = function (props) {
    var _a = React.useState('loading'), status = _a[0], setStatus = _a[1];
    var _b = React.useState([]), dashboardItems = _b[0], setDashboardItems = _b[1];
    var getItemsAsync = function () { return __awaiter(void 0, void 0, void 0, function () {
        var result, _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    _b.trys.push([0, 2, , 3]);
                    return [4, props.configuration.fnGetItemsAsync({
                            dashboardCode: props.dashboardCode,
                        })];
                case 1:
                    result = _b.sent();
                    setStatus('loaded');
                    setDashboardItems(result);
                    return [3, 3];
                case 2:
                    _a = _b.sent();
                    setStatus('error');
                    setDashboardItems([]);
                    return [3, 3];
                case 3: return [2];
            }
        });
    }); };
    useEffect(function () {
        getItemsAsync();
    }, []);
    if (status === 'loading') {
        if (props.configuration.loadingComponent)
            return props.configuration.loadingComponent;
        return (_jsx("div", { className: "s-dashboard s-dashboard-loading", children: _jsx("h1", { children: "Loading..." }) }));
    }
    if (status === 'error') {
        if (props.configuration.errorComponent)
            return props.configuration.errorComponent;
        return (_jsx("div", { className: "s-dashboard s-dashboard-error", children: _jsx("h1", { children: "Error" }) }));
    }
    return (_jsxs("div", { className: "s-dashboard s-dashboard-loaded", style: {
            gridTemplateColumns: "repeat(".concat(props.grid_column || 2, ", 1fr)"),
            background: props.background || 'transparent',
        }, children: [props.title && _jsx("h1", { className: "s-dashboard-title", children: props.title }), dashboardItems.map(function (item, index) {
                var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w, _x, _y, _z, _0, _1, _2, _3, _4, _5, _6, _7, _8, _9, _10, _11, _12, _13, _14, _15, _16, _17, _18, _19, _20, _21, _22, _23, _24, _25, _26, _27, _28, _29, _30, _31, _32, _33, _34, _35, _36, _37, _38, _39;
                switch (item.setup.type) {
                    case 'vertical-bar-chart':
                    case 'horizontal-bar-chart':
                        return (_jsxs("div", { className: "s-dasboard__item", style: {
                                gridColumn: "".concat(Number(item.setup.x) + 1, " / span ").concat(item.setup.width),
                                gridRow: "".concat(Number(item.setup.y) + 1, " / span ").concat(item.setup.height),
                            }, children: [(_c = (_b = (_a = item.setup.chart) === null || _a === void 0 ? void 0 : _a.title) === null || _b === void 0 ? void 0 : _b.show) !== null && _c !== void 0 ? _c : (_jsx("div", { className: "s-dashboard__title", style: {
                                        color: ((_f = (_e = (_d = item.setup.chart) === null || _d === void 0 ? void 0 : _d.title) === null || _e === void 0 ? void 0 : _e.textStyle) === null || _f === void 0 ? void 0 : _f.color) || '#000',
                                        fontSize: ((_j = (_h = (_g = item.setup.chart) === null || _g === void 0 ? void 0 : _g.title) === null || _h === void 0 ? void 0 : _h.textStyle) === null || _j === void 0 ? void 0 : _j.color) || 14,
                                    }, children: _jsx("p", { className: "s-dashboard__title--text", children: ((_m = (_l = (_k = item.setup.chart) === null || _k === void 0 ? void 0 : _k.title) === null || _l === void 0 ? void 0 : _l.text) === null || _m === void 0 ? void 0 : _m.trim()) || ((_o = item.setup.title) === null || _o === void 0 ? void 0 : _o.trim()) || '' }) })), _jsx(BarChart, { configuration: {
                                        fnGetChartDataAsync: props.configuration.fnGetChartDataAsync,
                                        setup: item.setup,
                                        loadingComponent: props.configuration.loadingComponentChartItem,
                                        errorComponent: props.configuration.errorComponentChartItem,
                                    } }, index), ((_p = item.setup.extraData) === null || _p === void 0 ? void 0 : _p.compare) && (_jsxs("div", { className: "s-dashboard__footer", children: [((_q = item.setup.extraData.compare) === null || _q === void 0 ? void 0 : _q.status) && (_jsx("div", { className: "s-dashboard__footer--arrow", itemType: item.setup.extraData.compare.status })), ((_r = item.setup.extraData.compare) === null || _r === void 0 ? void 0 : _r.value) && (_jsx("div", { className: "s-dashboard__footer--text", children: item.setup.extraData.compare.value }))] }))] }, index));
                    case 'line-chart':
                    case 'step-line-chart':
                        return (_jsxs("div", { className: "s-dasboard__item", style: {
                                gridColumn: "".concat(Number(item.setup.x) + 1, " / span ").concat(item.setup.width),
                                gridRow: "".concat(Number(item.setup.y) + 1, " / span ").concat(item.setup.height),
                            }, children: [(_u = (_t = (_s = item.setup.chart) === null || _s === void 0 ? void 0 : _s.title) === null || _t === void 0 ? void 0 : _t.show) !== null && _u !== void 0 ? _u : (_jsx("div", { className: "s-dashboard__title", style: {
                                        color: ((_x = (_w = (_v = item.setup.chart) === null || _v === void 0 ? void 0 : _v.title) === null || _w === void 0 ? void 0 : _w.textStyle) === null || _x === void 0 ? void 0 : _x.color) || '#000',
                                        fontSize: ((_0 = (_z = (_y = item.setup.chart) === null || _y === void 0 ? void 0 : _y.title) === null || _z === void 0 ? void 0 : _z.textStyle) === null || _0 === void 0 ? void 0 : _0.color) || 14,
                                    }, children: _jsx("p", { className: "s-dashboard__title--text", children: ((_3 = (_2 = (_1 = item.setup.chart) === null || _1 === void 0 ? void 0 : _1.title) === null || _2 === void 0 ? void 0 : _2.text) === null || _3 === void 0 ? void 0 : _3.trim()) || ((_4 = item.setup.title) === null || _4 === void 0 ? void 0 : _4.trim()) || '' }) })), _jsx(LineChart, { configuration: {
                                        fnGetChartDataAsync: props.configuration.fnGetChartDataAsync,
                                        setup: item.setup,
                                        loadingComponent: props.configuration.loadingComponentChartItem,
                                        errorComponent: props.configuration.errorComponentChartItem,
                                    } }, index), ((_5 = item.setup.extraData) === null || _5 === void 0 ? void 0 : _5.compare) && (_jsxs("div", { className: "s-dashboard__footer", children: [((_6 = item.setup.extraData.compare) === null || _6 === void 0 ? void 0 : _6.status) && (_jsx("div", { className: "s-dashboard__footer--arrow", itemType: item.setup.extraData.compare.status })), ((_7 = item.setup.extraData.compare) === null || _7 === void 0 ? void 0 : _7.value) && (_jsx("div", { className: "s-dashboard__footer--text", children: item.setup.extraData.compare.value }))] }))] }, index));
                    case 'pie-chart':
                        return (_jsxs("div", { className: "s-dasboard__item", style: {
                                gridColumn: "".concat(Number(item.setup.x) + 1, " / span ").concat(item.setup.width),
                                gridRow: "".concat(Number(item.setup.y) + 1, " / span ").concat(item.setup.height),
                            }, children: [(_10 = (_9 = (_8 = item.setup.chart) === null || _8 === void 0 ? void 0 : _8.title) === null || _9 === void 0 ? void 0 : _9.show) !== null && _10 !== void 0 ? _10 : (_jsx("div", { className: "s-dashboard__title", style: {
                                        color: ((_13 = (_12 = (_11 = item.setup.chart) === null || _11 === void 0 ? void 0 : _11.title) === null || _12 === void 0 ? void 0 : _12.textStyle) === null || _13 === void 0 ? void 0 : _13.color) || '#000',
                                        fontSize: ((_16 = (_15 = (_14 = item.setup.chart) === null || _14 === void 0 ? void 0 : _14.title) === null || _15 === void 0 ? void 0 : _15.textStyle) === null || _16 === void 0 ? void 0 : _16.color) || 14,
                                    }, children: _jsx("p", { className: "s-dashboard__title--text", children: ((_19 = (_18 = (_17 = item.setup.chart) === null || _17 === void 0 ? void 0 : _17.title) === null || _18 === void 0 ? void 0 : _18.text) === null || _19 === void 0 ? void 0 : _19.trim()) || ((_20 = item.setup.title) === null || _20 === void 0 ? void 0 : _20.trim()) || '' }) })), _jsx(PieChart, { configuration: {
                                        fnGetChartDataAsync: props.configuration.fnGetChartDataAsync,
                                        setup: item.setup,
                                        loadingComponent: props.configuration.loadingComponentChartItem,
                                        errorComponent: props.configuration.errorComponentChartItem,
                                    } }, index), ((_21 = item.setup.extraData) === null || _21 === void 0 ? void 0 : _21.compare) && (_jsxs("div", { className: "s-dashboard__footer", children: [((_22 = item.setup.extraData.compare) === null || _22 === void 0 ? void 0 : _22.status) && (_jsx("div", { className: "s-dashboard__footer--arrow", itemType: item.setup.extraData.compare.status })), ((_23 = item.setup.extraData.compare) === null || _23 === void 0 ? void 0 : _23.value) && (_jsx("div", { className: "s-dashboard__footer--text", children: item.setup.extraData.compare.value }))] }))] }, index));
                    case 'stack-area-chart':
                    case 'stack-bar-chart':
                        return (_jsxs("div", { className: "s-dasboard__item", style: {
                                gridColumn: "".concat(Number(item.setup.x) + 1, " / span ").concat(item.setup.width),
                                gridRow: "".concat(Number(item.setup.y) + 1, " / span ").concat(item.setup.height),
                            }, children: [(_26 = (_25 = (_24 = item.setup.chart) === null || _24 === void 0 ? void 0 : _24.title) === null || _25 === void 0 ? void 0 : _25.show) !== null && _26 !== void 0 ? _26 : (_jsx("div", { className: "s-dashboard__title", style: {
                                        color: ((_29 = (_28 = (_27 = item.setup.chart) === null || _27 === void 0 ? void 0 : _27.title) === null || _28 === void 0 ? void 0 : _28.textStyle) === null || _29 === void 0 ? void 0 : _29.color) || '#000',
                                        fontSize: ((_32 = (_31 = (_30 = item.setup.chart) === null || _30 === void 0 ? void 0 : _30.title) === null || _31 === void 0 ? void 0 : _31.textStyle) === null || _32 === void 0 ? void 0 : _32.color) || 14,
                                    }, children: _jsx("p", { className: "s-dashboard__title--text", children: ((_35 = (_34 = (_33 = item.setup.chart) === null || _33 === void 0 ? void 0 : _33.title) === null || _34 === void 0 ? void 0 : _34.text) === null || _35 === void 0 ? void 0 : _35.trim()) || ((_36 = item.setup.title) === null || _36 === void 0 ? void 0 : _36.trim()) || '' }) })), _jsx(StackChart, { configuration: {
                                        fnGetChartDataAsync: props.configuration.fnGetChartDataAsync,
                                        setup: item.setup,
                                        loadingComponent: props.configuration.loadingComponentChartItem,
                                        errorComponent: props.configuration.errorComponentChartItem,
                                    } }, index), ((_37 = item.setup.extraData) === null || _37 === void 0 ? void 0 : _37.compare) && (_jsxs("div", { className: "s-dashboard__footer", children: [((_38 = item.setup.extraData.compare) === null || _38 === void 0 ? void 0 : _38.status) && (_jsx("div", { className: "s-dashboard__footer--arrow", itemType: item.setup.extraData.compare.status })), ((_39 = item.setup.extraData.compare) === null || _39 === void 0 ? void 0 : _39.value) && (_jsx("div", { className: "s-dashboard__footer--text", children: item.setup.extraData.compare.value }))] }))] }, index));
                    default:
                        return _jsxs("div", { children: ["Unknown chart type: ", JSON.stringify(item.setup)] }, index);
                }
            })] }));
};
export default SDashboard;
